/*
** alarm_type.c
**
** This program is free software; you can redistribute it and/or modify
** it under the terms of the GNU General Public License as published by
** the Free Software Foundation; either version 2.1 of the License, or
** (at your option) any later version.
**
** This program is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
** GNU General Public License for more details.
**
** You should have received a copy of the GNU General Public License
** along with this program; if not, write to the Free Software
** Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
*/

#include "alarm_type.h"

#define OMSG_ALARM_TYPE (0x1f00)

extern const struct static_item menu_type;
extern const struct static_item menu_days;

extern unsigned short menu_status[];
extern rexx_uint confid_days;

/* UI messages dispatcher */
extern rexx_uint alarm_type_dispatcher_id; /* dispatcher's call id */
rexx("alarm_type_dispatcher_id=add_5e0_id(alarm_type_dispatcher)"); /* auto creation of the id */

unsigned alarm_type_dispatcher(unsigned msg)
{
 switch(msg)
 {

  case MSG_D_INIT:
  {
   unsigned int days = own_get_config(confid_days);
   app.days = days & ~1;   /* repeat flag off */
   open_static_menu((const struct menu *)&menu_type, alarm_clock_status & days & 1, MENU_MASK_SHOW_ALL);
   //send_message(MSG_OPEN_STATIC_MENU|MSG_1P,&menu_type);
   msg=MSG_R_STAY;
   break;
  }

  case MSG_D_QUIT:
  {
   msg=MSG_R_QUIT;
   break;
  }

  /* the alarm type was selected in menu; arg0 is the type (0 - once, 1 - repeated) */
  case OMSG_ALARM_TYPE:
  {
   if( msg_argv[0] == 0 ) /* once */
   {
    send_message(MSG_REQUEST_QUIT_OK);
   }
   else /* repeated */
   {
    send_message(MSG_OPEN_STATIC_MENU|MSG_1P,&menu_days);
   }
   msg=MSG_NOP;
   break;
  }

  case MSG_SWITCHABLE_MENU_BACK:
  {
   /* Behave like the day flags were all clear when the menu was opened
      Forces the "save changes" to appear always if any days are selected */
   menu_status[3]=0;
   break;
  }

  case MSG_SWITCHABLE_MENU_STATUS:
  {
   if( msg_argv[0] != 0 ) {
      app.days += 1;   /* repeat flag on */
      send_message(MSG_REQUEST_QUIT_OK);
   }
   break;
  }

 }
 return msg;
}

